/*----------------------------------------------------------------------------
/ M-800AD												2005 (C)LogicPack
/	Version		Date							Name
/	000			'05.12.12						M.Yamada
/		first release(/CS3, board ID 0p)
/	001			'05.12.24						M.Yamada
/		lib
/---------------------------------------------------------------------------*/
#include "iodefine.h"
#include "m800ad.h"
#include "m800ad.def"

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
/*--- address ---*/
#define	CS3_ADDR	0x600000
#define CS4_ADDR	0x800000
#define CS5_ADDR	0xA00000
#define CS6_ADDR	0xC00000
#define CS7_ADDR	0xE00000

#define M800AD_OFS	0x1000

/*--- I/O access ---*/
#define M800AD_DATA	(*(volatile word *)(area_addr + board_id + 0x00))	/* R */
#define M800AD_CNVS	(*(volatile byte *)(area_addr + board_id + 0x00))	/* W */
#define M800AD_IF	(*(volatile byte *)(area_addr + board_id + 0x02))	/* R */
#define M800AD_MPX	(*(volatile byte *)(area_addr + board_id + 0x02))	/* W */

/* ADobt@Ǘ\ */
typedef struct{
	word *buf;
	int size;
	int index;
}M800AD_BUFINFO;

#define CH_MAX		8		/* A/D ch */

/*-----------------------------------------------
/ *STATIC
/----------------------------------------------*/
static word ad_data[CH_MAX];
static M800AD_BUFINFO ad_buffer[CH_MAX];
static bool scan_index = 0;
static dword area_addr = CS3_ADDR + M800AD_OFS;
static int board_id = 0;

static volatile bool attend_flag = FALSE;
static volatile bool scan_mode = FALSE;
static volatile bool run_flag = FALSE;
static volatile bool end_flag = FALSE;	/* A/DItO */

static void dummy(void);

/*-------------------------------------------------------------------
/ 
/------------------------------------------------------------------*/
void M800adInit(void)
{
	ENABLE_INTR();
}

/*-------------------------------------------------------------------
/ Board IDI
/------------------------------------------------------------------*/
bool M800adConfig(int cs,int bid)
{
	switch( cs ){
		case 3: area_addr = CS3_ADDR + M800AD_OFS; break;
		case 4: area_addr = CS4_ADDR + M800AD_OFS; break;
		case 5: area_addr = CS5_ADDR + M800AD_OFS; break;
		case 6: area_addr = CS6_ADDR + M800AD_OFS; break;
		case 7: area_addr = CS7_ADDR + M800AD_OFS; break;
		default: return FALSE;
	}
	if(bid >= 0 && bid <= 15){
		board_id = (bid << 8);
	}
	else{
		return FALSE;
	}
	return TRUE;
}

/*-------------------------------------------------------------------
/ I
/------------------------------------------------------------------*/
void M800adChSel(int sel)
{
	int i;
	M800AD_MPX = (byte)(sel & 0x07);
	/* chI25usȏ̃EGCg */
	for( i = 0; i < 10; i++ ){ dummy(); }
}

static void dummy(void){}

/*-------------------------------------------------------------------
/ A/DX^[g
/	ENT:
/	  bool attend					TRUE:f[^A擾
/	  bool scan						TRUE:chXL
/	ATN:
/	  attendTRUEw肷ꍇA
/	  OM800adSetBuffer()ɂݒ肪Kv
/------------------------------------------------------------------*/
void M800adStart(bool attend, bool scan)
{
	DISABLE_INTR();
	end_flag = FALSE;		/* flag clear */
	ENABLE_INTR();

	scan_mode = scan;
	if( scan ){
		scan_index = 0;
		M800adChSel(scan_index);			/* chI */
	}
	attend_flag = attend;
	run_flag = TRUE;
}

/*-------------------------------------------------------------------
/ A/DX^[g
/------------------------------------------------------------------*/
void M800adRestart(void)
{
	if( run_flag ){
		M800AD_CNVS = 0x00;				/* A/DϊX^[g */
	}
}

/*-------------------------------------------------------------------
/ A/Df[^擾
/------------------------------------------------------------------*/
word M800adGetData(void)
{
	return ad_data[0];
}

/*-------------------------------------------------------------------
/ scan modeA/Df[^擾
/------------------------------------------------------------------*/
void M800adGetDatas(word *data)
{
	int i;
	for( i = 0; i < CH_MAX; i++ , data++){
		*data = ad_data[i];
	}
}

/*-------------------------------------------------------------------
/ obt@ݒ
/	ENT:
/	  word *buffer					obt@ւ̃|C^
/	  int size						obt@TCY
/------------------------------------------------------------------*/
void M800adSetBuffer(word *buffer, int size)
{
	ad_buffer[0].buf = buffer;
	ad_buffer[0].size = size;
	ad_buffer[0].index = 0;
}

/*-------------------------------------------------------------------
/ chʃobt@ݒ
/	ENT:
/	  int ch						ch
/	  word *buffer					obt@ւ̃|C^
/	  int size						obt@TCY
/	  int cycle						A/D
/------------------------------------------------------------------*/
void M800adSetChBuffer(int ch, word *buffer, int size)
{
	ad_buffer[ch].buf = buffer;
	ad_buffer[ch].size = size;
	ad_buffer[ch].index = 0;
}

/*-------------------------------------------------------------------
/ A/DI?
/------------------------------------------------------------------*/
bool M800adIsEnd(void)
{
	bool endf;
	DISABLE_INTR();
	endf = end_flag;
	if( endf ){ end_flag = FALSE; }
	ENABLE_INTR();
	return endf;
}

/*-------------------------------------------------------------------
/ 荞
/------------------------------------------------------------------*/
void M800adIntr(void)
{
	int nch;					/* next ch */
	if( M800AD_IF  & 0x01 ){
		/* scan modeAcĥ߂Ƀ}`vNT
			炩ߐ؂ւĂ */
		if( scan_mode ){
			nch = scan_index + 1;
			if( nch < CH_MAX ){
				M800adChSel(nch);
			}
		}
		/*------ A擾 ------*/
		if( attend_flag ){
			M800AD_BUFINFO *adbp;
			/*--- ch scan mode ---*/
			if( scan_mode ){
				adbp = &ad_buffer[scan_index];
				adbp->buf[adbp->index] = M800AD_DATA;
				adbp->index++;
				if( ++scan_index == CH_MAX ){
					if( adbp->index == adbp->size ){
						attend_flag = FALSE;
						end_flag = TRUE;
						run_flag=FALSE;
					}else{
						scan_index = 0;
						M800adChSel(scan_index);
					}
				}
			}
			/*--- Œ ch mode ---*/
			else{
				adbp = &ad_buffer[0];
				adbp->buf[adbp->index] = M800AD_DATA;
				if( ++adbp->index == adbp->size ){
					attend_flag = FALSE;
					end_flag = TRUE;
					run_flag=FALSE;
				}
			}
		}
		/*------ P̎擾 ------*/
		else{
			/*--- ch scan mode ---*/
			if( scan_mode ){
				ad_data[scan_index] = M800AD_DATA;
				if( ++scan_index == CH_MAX ){
					end_flag = TRUE;
					run_flag=FALSE;
				}
			}
			/*--- Œ ch mode ---*/
			else{
				ad_data[0] = M800AD_DATA;
				end_flag = TRUE;
				run_flag=FALSE;
			}
		}
	}
}
